Bug 1290524 - Review Request: libdkimpp - Lightweight and portable DKIM (RFC4871) library
Review Request: libdkimpp - Lightweight and portable DKIM (RFC4871) library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Antonio Trande
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-10 12:36 EST by Denis Fateyev
Modified: 2016-01-28 14:24 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-20 16:54:25 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
anto.trande: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Denis Fateyev 2015-12-10 12:36:55 EST
Spec URL: http://www.fateyev.com/RPMS/Fedora22/libdkimpp.spec
SRPM URL: http://www.fateyev.com/RPMS/Fedora22/libdkimpp-1.0.8-1.fc24.src.rpm
Description: libdkim++ is a lightweight and portable DKIM (RFC4871) library for *NIX, supporting both signing and DMARC/SDID/ADSP verification, sponsored and used by Halon Security. libdkim++ has extensive unit test coverage and aims to fully comply with the current RFC.
Fedora Account System Username: dfateyev

Koji scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=12139519 (Rawhide)
https://koji.fedoraproject.org/koji/taskinfo?taskID=12139516 (EPEL 7)
Comment 1 Upstream Release Monitoring 2016-01-07 08:37:59 EST
dfateyev's scratch build of libdkimpp-1.0.8-1.fc20.denf.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12449521
Comment 2 Antonio Trande 2016-01-12 05:20:48 EST
Taken.
Please, review libpwiz (https://bugzilla.redhat.com/show_bug.cgi?id=1292392) if you can.
Comment 3 Upstream Release Monitoring 2016-01-12 05:47:30 EST
sagitter's scratch build of libdkimpp-1.0.8-1.fc24.src.rpm for epel7 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12514162
Comment 4 Antonio Trande 2016-01-12 05:59:42 EST
Package approved.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: coreutils make gcc-c++
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

- 'Full Relro' feature is not mandatory for libraries on EPEL; this is
  just for info:

  'Partial Relro' warning of 'libdkim++.so.1.0.8' in the EPEL7 build.
  https://fedoraproject.org/wiki/Changes/Harden_All_Packages


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v3 or later)", "Unknown or generated". 19 files have
     unknown license. Detailed output of licensecheck in
     /home/sagitter/FedoraReview/1290524-libdkimpp/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     libdkimpp-debuginfo
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libdkimpp-1.0.8-1.fc24.x86_64.rpm
          libdkimpp-devel-1.0.8-1.fc24.x86_64.rpm
          libdkimpp-debuginfo-1.0.8-1.fc24.x86_64.rpm
          libdkimpp-1.0.8-1.fc24.src.rpm
libdkimpp.x86_64: W: spelling-error %description -l en_US libdkim -> Librium
libdkimpp-devel.x86_64: W: only-non-binary-in-usr-lib
libdkimpp-devel.x86_64: W: no-documentation
libdkimpp.src: W: spelling-error %description -l en_US libdkim -> Librium
4 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libdkimpp-debuginfo-1.0.8-1.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
libdkimpp.x86_64: W: spelling-error %description -l en_US libdkim -> Librium
libdkimpp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libdkim++.so.1.0.8 /lib64/libssl.so.10
libdkimpp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libdkim++.so.1.0.8 /lib64/libm.so.6
libdkimpp-devel.x86_64: W: only-non-binary-in-usr-lib
libdkimpp-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 5 warnings.



Requires
--------
libdkimpp (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libresolv.so.2()(64bit)
    libssl.so.10()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

libdkimpp-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libdkim++.so.1()(64bit)
    libdkimpp(x86-64)

libdkimpp-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
libdkimpp:
    libdkim++.so.1()(64bit)
    libdkimpp
    libdkimpp(x86-64)

libdkimpp-devel:
    libdkimpp-devel
    libdkimpp-devel(x86-64)
    pkgconfig(libdkim++)

libdkimpp-debuginfo:
    libdkimpp-debuginfo
    libdkimpp-debuginfo(x86-64)



Source checksums
----------------
https://github.com/halonsecurity/libdkimpp/archive/v1.0.8.tar.gz :
  CHECKSUM(SHA256) this package     : b0995a650af6fbd7b7b0a224caa4dcce9b3b80d3fec84950530bbb58cb21b79d
  CHECKSUM(SHA256) upstream package : b0995a650af6fbd7b7b0a224caa4dcce9b3b80d3fec84950530bbb58cb21b79d


Generated by fedora-review 0.6.0 (7737a2a) last change: 2015-11-26
Command line :./try-fedora-review -m fedora-rawhide-x86_64 -b 1290524
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 5 Denis Fateyev 2016-01-12 07:16:13 EST
Thanks for the review. I'll look at libpwiz shortly.

> - All build dependencies are listed in BuildRequires, except for any that
>  are listed in the exceptions section of Packaging Guidelines.
>  Note: These BR are not needed: coreutils make gcc-c++
>  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

Due to the latest version of the packaging guidelines, all dependencies should be listed, the exception list is gone. For more info:
https://fedoraproject.org/wiki/Packaging:Guidelines#BuildRequires_2
https://fedorahosted.org/fpc/ticket/497

> - 'Full Relro' feature is not mandatory for libraries on EPEL; this is
>  just for info:
>
>  'Partial Relro' warning of 'libdkim++.so.1.0.8' in the EPEL7 build.
>  https://fedoraproject.org/wiki/Changes/Harden_All_Packages

I can't reproduce this with rpmlint, could you get more info where you can see this? I'll add `_hardened_build` to the spec, anyway.
Comment 6 Antonio Trande 2016-01-12 08:08:28 EST
(In reply to Denis Fateyev from comment #5)
> > - 'Full Relro' feature is not mandatory for libraries on EPEL; this is
> >  just for info:
> >
> >  'Partial Relro' warning of 'libdkim++.so.1.0.8' in the EPEL7 build.
> >  https://fedoraproject.org/wiki/Changes/Harden_All_Packages
> 
> I can't reproduce this with rpmlint, could you get more info where you can
> see this? I'll add `_hardened_build` to the spec, anyway.

Use 'checksec' tool.
I don't know if _hardened_build is supported on EPEL but using "-Wl,-z,now" flag should be enough.
Comment 7 Denis Fateyev 2016-01-12 12:37:47 EST
(In reply to Antonio Trande from comment #6)
> I don't know if _hardened_build is supported on EPEL but using "-Wl,-z,now"
> flag should be enough.

It's supported; and solves the problem in a nutshell (Full Relro).
Comment 8 Gwyn Ciesla 2016-01-12 13:13:40 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/libdkimpp
Comment 9 Fedora Update System 2016-01-12 14:40:25 EST
libdkimpp-1.0.8-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-b91f842baa
Comment 10 Fedora Update System 2016-01-12 14:40:31 EST
libdkimpp-1.0.8-1.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-ead0275590
Comment 11 Fedora Update System 2016-01-13 01:51:44 EST
libdkimpp-1.0.8-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-bae9540fb7
Comment 12 Fedora Update System 2016-01-13 02:21:57 EST
libdkimpp-1.0.8-1.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-ead0275590
Comment 13 Fedora Update System 2016-01-13 02:53:30 EST
libdkimpp-1.0.8-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-b91f842baa
Comment 14 Fedora Update System 2016-01-20 16:54:23 EST
libdkimpp-1.0.8-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 15 Fedora Update System 2016-01-20 23:48:18 EST
libdkimpp-1.0.8-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 16 Fedora Update System 2016-01-28 14:24:59 EST
libdkimpp-1.0.8-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.